if not PriorityQueue then return end

if select(2, UnitClass('player')) ~= "MAGE" then
	return
end

local L = LibStub("AceLocale-3.0"):GetLocale("PriorityQueue")
local C = PriorityQueue.constants -- Defined in PriorityQueue LUA no locale needed.

C["GCD Spell"] = GetSpellInfo(1459)
C["Scorch"], _, C["Scorch Icon"] = GetSpellInfo(2948)
C["Fireball"], _, C["Fireball Icon"] = GetSpellInfo(133)
C["Frostbolt"], _, C["Frostbolt Icon"] = GetSpellInfo(116)

-- Procs:
C["Fireball!"] = GetSpellInfo(57761)

function PriorityQueue:UNIT_MANA()
	if self.db.char.priority.show and InCombatLockdown() then
		self:SetNextPriority()
	end
end

---------------------------
-- Mage Priorities
---------------------------

function PriorityQueue:GetMagePriorityDefaults()
	self:RegisterEvent("UNIT_MANA")
	-- need a function to work out spec for now fixed values
	self.presets.priorities.name["Fire"] =  L["Fire"]
	self.presets.priorities.list["Fire"] = { "s", "none",  "none",  "none", "none", "none", "none", "none", "none", "none" }
	self.presets.priorities.name["Frost"] =  L["Frost"]
	self.presets.priorities.list["Frost"] = { "bf_fb", "frb",  "none",  "none", "none", "none", "none", "none", "none", "none" }
	self.presets.default = "Fire"
end

PriorityQueue.priorityTable.name["s"] = C["Scorch"]
PriorityQueue.priorityTable.icon["s"] = C["Scorch Icon"]
PriorityQueue.priorityTable.test["s"] = 
	function () 
		if not PriorityQueue:SpellAvailable(C["Scorch"]) then 
			return false
		end
		local sdebuff, sduration = PriorityQueue:GetDebuffInfo(C["Scorch"])
		return not sdebuff or ( sduration < self:GetExpectedCastTime(1.5) )
	end 

PriorityQueue.priorityTable.name["fb"] = C["Fireball"]
PriorityQueue.priorityTable.icon["fb"] = C["Fireball Icon"]
PriorityQueue.priorityTable.test["fb"] = 
	function () 
		return PriorityQueue:SpellAvailable(C["Fireball"])
	end
	
PriorityQueue.priorityTable.name["frb"] = C["Frostbolt"]
PriorityQueue.priorityTable.icon["frb"] = C["Frostbolt Icon"]
PriorityQueue.priorityTable.test["frb"] = 
	function () 
		return PriorityQueue:SpellAvailable(C["Frostbolt"])
	end
	
PriorityQueue.priorityTable.name["bf_fb"] = L["Fireball with Brain Freeze"]
PriorityQueue.priorityTable.icon["bf_fb"] = C["Fireball Icon"]
PriorityQueue.priorityTable.test["bf_fb"] = 
	function () 
		return PriorityQueue:SpellAvailable(C["Fireball"]) and PriorityQueue:GetBuffInfo(C["Fireball!"])
	end