if not PriorityQueue then return end

if select(2, UnitClass('player')) ~= "PALADIN" then
	return
end

local L = LibStub("AceLocale-3.0"):GetLocale("PriorityQueue")
local C = PriorityQueue.constants -- Defined in PriorityQueue LUA no locale needed.

C["GCD Spell"] = GetSpellInfo(19750)
C["Holy Shield"], _, C["Holy Shield Icon"] = GetSpellInfo(48952)
C["Hammer of the Righteous"], _, C["Hammer of the Righteous Icon"] = GetSpellInfo(53595)
C["Judgement of Wisdom"], _, C["Judgement of Wisdom Icon"] = GetSpellInfo(53408)
C["Shield of Righteousness"], _, C["Shield of Righteousness Icon"] = GetSpellInfo(61411)
C["Consecration"], _, C["Consecration Icon"] = GetSpellInfo(48819)
C["Judgement of Light"], _, C["Judgement of Light Icon"] = GetSpellInfo(20271)
C["Exorcism"], _, C["Exorcism Icon"] = GetSpellInfo(48801)
C["Crusader Strike"], _, C["Crusader Strike Icon"] = GetSpellInfo(35395)
C["Divine Storm"], _, C["Divine Storm Icon"] = GetSpellInfo(53385)
C["Hammer of Wrath"], _, C["Hammer of Wrath Icon"] = GetSpellInfo(48806)

-- Buffs/Procs:
C["The Art of War"] = GetSpellInfo(59578);

function PriorityQueue:UNIT_MANA()
	if self.db.char.priority.show and InCombatLockdown() then
		self:SetNextPriority()
	end
end

---------------------------
-- Paladin Priorities
---------------------------

function PriorityQueue:GetPaladinPriorityDefaults()
	self:RegisterEvent("UNIT_MANA")
	-- need a function to work out spec for now fixed values
	self.presets.priorities.name["Protection"] =  L["Protection"]
	self.presets.priorities.list["Protection"] = { "hs", "hotr",  "jow",  "sor", "con", "none", "none", "none", "none", "none" }
	self.presets.default = "Protection"

    self.presets.priorities.name["Retribution"] =  L["Retribution"]
	self.presets.priorities.list["Retribution"] = { "cs", "how",  "jow",  "ds", "exorcism", "con", "none", "none", "none", "none" }
end

PriorityQueue.priorityTable.name["hs"] = C["Holy Shield"]
PriorityQueue.priorityTable.icon["hs"] = C["Holy Shield Icon"]
PriorityQueue.priorityTable.test["hs"] = 
	function () 
		return PriorityQueue:SpellAvailable(C["Holy Shield"])
	end 

PriorityQueue.priorityTable.name["hotr"] = C["Hammer of the Righteous"]
PriorityQueue.priorityTable.icon["hotr"] = C["Hammer of the Righteous Icon"]
PriorityQueue.priorityTable.test["hotr"] = 
	function () 
		return PriorityQueue:SpellAvailable(C["Hammer of the Righteous"])
	end 

PriorityQueue.priorityTable.name["jow"] = C["Judgement of Wisdom"]
PriorityQueue.priorityTable.icon["jow"] = C["Judgement of Wisdom Icon"]
PriorityQueue.priorityTable.test["jow"] = 
	function () 
		return PriorityQueue:SpellAvailable(C["Judgement of Wisdom"])
	end 

PriorityQueue.priorityTable.name["sor"] = C["Shield of Righteousness"]
PriorityQueue.priorityTable.icon["sor"] = C["Shield of Righteousness Icon"]
PriorityQueue.priorityTable.test["sor"] =  
	function () 
		return PriorityQueue:SpellAvailable(C["Shield of Righteousness"])
	end 
	
PriorityQueue.priorityTable.name["con"] = C["Consecration"]
PriorityQueue.priorityTable.icon["con"] = C["Consecration Icon"]
PriorityQueue.priorityTable.test["con"] = 
	function () 
		return PriorityQueue:SpellAvailable(C["Consecration"])
	end

PriorityQueue.priorityTable.name["jol"] = C["Judgement of Light"]
PriorityQueue.priorityTable.icon["jol"] = C["Judgement of Light Icon"]
PriorityQueue.priorityTable.test["jol"] = 
	function () 
		return PriorityQueue:SpellAvailable(C["Judgement of Light"])
	end

PriorityQueue.priorityTable.name["exorcism"] = C["Exorcism"]
PriorityQueue.priorityTable.icon["exorcism"] = C["Exorcism Icon"]
PriorityQueue.priorityTable.test["exorcism"] = 
	function () 
		return PriorityQueue:SpellAvailable(C["Exorcism"]) and PriorityQueue:GetBuffInfo(C["The Art of War"])
	end

PriorityQueue.priorityTable.name["cs"] = C["Crusader Strike"]
PriorityQueue.priorityTable.icon["cs"] = C["Crusader Strike Icon"]
PriorityQueue.priorityTable.test["cs"] = 
	function () 
		return PriorityQueue:SpellAvailable(C["Crusader Strike"])
	end

PriorityQueue.priorityTable.name["ds"] = C["Divine Storm"]
PriorityQueue.priorityTable.icon["ds"] = C["Divine Storm Icon"]
PriorityQueue.priorityTable.test["ds"] = 
	function () 
		return PriorityQueue:SpellAvailable(C["Divine Storm"])
	end

PriorityQueue.priorityTable.name["how"] = C["Hammer of Wrath"]
PriorityQueue.priorityTable.icon["how"] = C["Hammer of Wrath Icon"]
PriorityQueue.priorityTable.test["how"] = 
	function () 
		local unithealth = 100 * UnitHealth("target") / UnitHealthMax("target")
		if unithealth <= 20 then -- only usable if target health < 20%
			return PriorityQueue:SpellAvailable(C["Hammer of Wrath"])
		end
		return false
	end