if not PriorityQueue then return end

if select(2, UnitClass('player')) ~= "SHAMAN" then
	return
end

local L = LibStub("AceLocale-3.0"):GetLocale("PriorityQueue")
local C = PriorityQueue.constants -- Defined in PriorityQueue LUA no locale needed.

C["GCD Spell"] = GetSpellInfo(49281)
C["Stormstrike"], _, C["Stormstrike Icon"] = GetSpellInfo(32176)
C["Windfury Attack"], _, C["Windfury Attack Icon"] = GetSpellInfo(25584)
C["Frost Shock"], _, C["Frost Shock Icon"] = GetSpellInfo(49236)
C["Earth Shock"], _, C["Earth Shock Icon"] = GetSpellInfo(49231)
C["Flame Shock"], _, C["Flame Shock Icon"] = GetSpellInfo(49233)
C["Wind Shock"], _, C["Wind Shock Icon"] = GetSpellInfo(57994)
C["Lava Lash"], _, C["Lava Lash Icon"] = GetSpellInfo(60103)
C["Lava Burst"], _, C["Lava Burst Icon"] = GetSpellInfo(51505)
C["Maelstrom Weapon"], _, C["Maelstrom Weapon Icon"] = GetSpellInfo(51532)
C["Water Shield"], _, C["Water Shield Icon"] = GetSpellInfo(33736)
C["Lightning Shield"], _, C["Lightning Shield Icon"] = GetSpellInfo(49281)
C["Earth Shield"], _, C["Earth Shield Icon"] = GetSpellInfo(49284)
C["Elemental Devastation"], _, C["Elemental Devastation Icon"] = GetSpellInfo(29178)
C["Flurry"], _, C["Flurry Icon"] = GetSpellInfo(16284)
if PriorityQueue.patch31 then
	C["Unleashed Rage"], _, C["Unleashed Rage Icon"] = GetSpellInfo(30809)
else
	C["Unleashed Rage"], _, C["Unleashed Rage Icon"] = GetSpellInfo(30807)
end
C["Windfury Weapon"], _, C["Windfury Weapon Icon"] = GetSpellInfo(58804)
C["Flametongue Weapon"], _, C["Flametongue Weapon Icon"] = GetSpellInfo(58790)
C["Frostbrand Weapon"], _, C["Frostbrand Weapon Icon"] = GetSpellInfo(58796)
C["Earthliving Weapon"], _, C["Earthliving Weapon Icon"] = GetSpellInfo(51994)
C["Lightning Bolt"], _, C["Lightning Bolt Icon"] = GetSpellInfo(49238)
C["Chain Lightning"], _, C["Chain Lightning Icon"] = GetSpellInfo(49271)
C["Heroic Presence"], _, C["Heroic Presence Icon"] = GetSpellInfo(28878)
C["Shamanistic Rage"], _, C["Shamanistic Rage Icon"] = GetSpellInfo(30823)
C["Feral Spirit"], _, C["Feral Spirit Icon"] = GetSpellInfo(51533)
C["Healing Wave"], _, C["Healing Wave Icon"] = GetSpellInfo(49273)
C["Chain Heal"], _, C["Chain Heal Icon"] = GetSpellInfo(55459)
C["Searing Totem"], _, C["Searing Totem Icon"] = GetSpellInfo(58704)
C["Magma Totem"], _, C["Magma Totem Icon"] = GetSpellInfo(58734)
C["Totem of Wrath"], _, C["Totem of Wrath"] = GetSpellInfo(30706)

---------------------------
-- Shaman Events
---------------------------

function PriorityQueue:UNIT_MANA()
	if self.db.char.priority.show and InCombatLockdown() then
		self:SetNextPriority()
	end
end

---------------------------
-- Shaman Priorities
---------------------------

function PriorityQueue:GetShamanPriorityDefaults()
	self:RegisterEvent("UNIT_MANA")
	self.db.char.priority.dropthreat.name = C["Wind Shock"]
	self.db.char.priority.dropthreat.icon = C["Wind Shock Icon"]

	-- need a function to work out spec for now fixed values
	self.presets.priorities.name["Enhance"] = L["Enhancement"]
	self.presets.priorities.name["Elemental"] = L["Elemental"]
	self.presets.priorities.list["Enhance"] = { "mw5_lb", "es_ss", "ss", "es", "ll", "st", "none", "none", "none", "none" }
	self.presets.priorities.list["Elemental"] = { "fs", "fs_lvb", "lvb", "lb", "tow", "ws", "none", "none", "none", "none" }
	self.presets.default = "Enhance"
end

PriorityQueue.priorityTable.name["mw5_lb"] = L["MW5 Lightning Bolt"]
PriorityQueue.priorityTable.icon["mw5_lb"] = C["Lightning Bolt Icon"]
PriorityQueue.priorityTable.test["mw5_lb"] = 
	function () 
		return PriorityQueue:GetMaelstromInfo() == 5 
	end 

PriorityQueue.priorityTable.name["mw4_lb"] = L["MW4 Lightning Bolt"]
PriorityQueue.priorityTable.icon["mw4_lb"] = C["Lightning Bolt Icon"]
PriorityQueue.priorityTable.test["mw4_lb"] = 
	function () 
		return PriorityQueue:GetMaelstromInfo() >= 4 
	end 

PriorityQueue.priorityTable.name["mw5_cl"] = L["MW5 Chain Lightning"]
PriorityQueue.priorityTable.icon["mw5_cl"] = C["Chain Lightning Icon"]
PriorityQueue.priorityTable.test["mw5_cl"] = 
	function () 
		return PriorityQueue:GetMaelstromInfo() == 5 and PriorityQueue:SpellAvailable(C["Chain Lightning"])
	end 

PriorityQueue.priorityTable.name["mw4_cl"] = L["MW4 Chain Lightning"]
PriorityQueue.priorityTable.icon["mw4_cl"] = C["Chain Lightning Icon"]
PriorityQueue.priorityTable.test["mw4_cl"] = 
	function () 
		return PriorityQueue:GetMaelstromInfo() >= 5 and PriorityQueue:SpellAvailable(C["Chain Lightning"])
	end 

PriorityQueue.priorityTable.name["ss"] = C["Stormstrike"]
PriorityQueue.priorityTable.icon["ss"] = C["Stormstrike Icon"]
PriorityQueue.priorityTable.test["ss"] =  
	function () 
		return PriorityQueue:SpellAvailable(C["Stormstrike"])
	end 

PriorityQueue.priorityTable.name["lb"] = C["Lightning Bolt"]
PriorityQueue.priorityTable.icon["lb"] = C["Lightning Bolt Icon"]
PriorityQueue.priorityTable.test["lb"] =  
	function () 
		return PriorityQueue:SpellAvailable(C["Lightning Bolt"])
	end 

PriorityQueue.priorityTable.name["cl"] = C["Chain Lightning"]
PriorityQueue.priorityTable.icon["cl"] = C["Chain Lightning Icon"]
PriorityQueue.priorityTable.test["cl"] =  
	function () 
		return PriorityQueue:SpellAvailable(C["Chain Lightning"])
	end 

PriorityQueue.priorityTable.name["es"] = C["Earth Shock"]
PriorityQueue.priorityTable.icon["es"] = C["Earth Shock Icon"]
PriorityQueue.priorityTable.test["es"] =  
	function () 
		return PriorityQueue:SpellAvailable(C["Earth Shock"])
	end 

PriorityQueue.priorityTable.name["es_ss"] = L["Earth Shock if SS"]
PriorityQueue.priorityTable.icon["es_ss"] = C["Earth Shock Icon"]
PriorityQueue.priorityTable.test["es_ss"] =  
	function () 
		return PriorityQueue:GetDebuffInfo(C["Stormstrike"]) and PriorityQueue:SpellAvailable(C["Earth Shock"])
	end 

PriorityQueue.priorityTable.name["fs"] = C["Flame Shock"]
PriorityQueue.priorityTable.icon["fs"] = C["Flame Shock Icon"]
PriorityQueue.priorityTable.test["fs"] =  
	function () 
		return not PriorityQueue:GetDebuffInfo(C["Flame Shock"]) and PriorityQueue:SpellAvailable(C["Flame Shock"])
	end 
	
PriorityQueue.priorityTable.name["lvb"] = C["Lava Burst"]
PriorityQueue.priorityTable.icon["lvb"] = C["Lava Burst Icon"]
PriorityQueue.priorityTable.test["lvb"] =  
	function () 
		return PriorityQueue:GetDebuffInfo(C["Flame Shock"]) and PriorityQueue:SpellAvailable(C["Lava Burst"])
	end 
	
PriorityQueue.priorityTable.name["fs_lvb"] = L["FS before LvB"]
PriorityQueue.priorityTable.icon["fs_lvb"] = C["Flame Shock Icon"]
PriorityQueue.priorityTable.test["fs_lvb"] =  
	function () 
		if not PriorityQueue:SpellAvailable(C["Flame Shock"]) then 
			return false
		end
		local fsdebuff, fsduration = PriorityQueue:GetDebuffInfo(C["Flame Shock"])
		local lvbcasttime = PriorityQueue:GetExpectedCastTime(2) + PriorityQueue:GetExpectedGCD() + PriorityQueue.db.char.priority.cooldown 
		-- lvbcasttime is expected time between casting FS and end of cast of LvB - note this is a hasted GCD AFTER FS cast and the hasted cast time of LvB (2 sec default)
		-- ie: after casting FS you need to wait a hasted GCD before you can START to cast LvB. casting takes hasted 2 seconds so the FS debuff must last a GCD + 2 sec (hasted)
		local _, lvbduration = PriorityQueue:SpellAvailable(C["Lava Burst"]) -- time left before LvB available
		return not fsdebuff or (fsduration <=  lvbcasttime and lvbduration <= PriorityQueue:GetExpectedGCD() + PriorityQueue.db.char.priority.cooldown)
	end 

	PriorityQueue.priorityTable.name["ll"] = C["Lava Lash"]
PriorityQueue.priorityTable.icon["ll"] = C["Lava Lash Icon"]
PriorityQueue.priorityTable.test["ll"] =  
	function () 
		return PriorityQueue:SpellAvailable(C["Lava Lash"])
	end 
	
PriorityQueue.priorityTable.name["st"] = C["Searing Totem"]
PriorityQueue.priorityTable.icon["st"] = C["Searing Totem Icon"]
PriorityQueue.priorityTable.test["st"] =  
	function () 
		if PriorityQueue:GetGCD(C["Lightning Shield"]) <= PriorityQueue.db.char.priority.cooldown then
			-- only bother checking for totem availabilty if we have a GCD
			local _, totemname, start, duration = GetTotemInfo(1)
			if not totemname or totemname == "" then -- no fire totem deployed so recommend it be dropped
				return true
			end
			if start and strmatch(totemname, C["Searing Totem"]) then
				local timeleft = start + duration - GetTime()
				return timeleft <= PriorityQueue.db.char.priority.cooldown 
			end
		end
		return false
	end 

PriorityQueue.priorityTable.name["mt"] = C["Magma Totem"]
PriorityQueue.priorityTable.icon["mt"] = C["Magma Totem Icon"]
PriorityQueue.priorityTable.test["mt"] =  
	function () 
		if PriorityQueue:GetGCD(C["Lightning Shield"]) <= PriorityQueue.db.char.priority.cooldown then
			-- only bother checking for totem availabilty if we have a GCD
			local _, totemname, start, duration = GetTotemInfo(1)
			if not totemname or totemname == "" then -- no fire totem deployed so recommend it be dropped
				return true
			end
			if start and strmatch(totemname, C["Magma Totem"]) then
				local timeleft = start + duration - GetTime()
				return timeleft <= PriorityQueue.db.char.priority.cooldown 
			end
		end
		return false
	end 

PriorityQueue.priorityTable.name["tow"] = C["Totem of Wrath"]
PriorityQueue.priorityTable.icon["tow"] = C["Totem of Wrath Icon"]
PriorityQueue.priorityTable.test["tow"] =  
	function () 
		if PriorityQueue:GetGCD(C["Lightning Shield"]) <= PriorityQueue.db.char.priority.cooldown then
			-- only bother checking for totem availabilty if we have a GCD
			local _, totemname, start, duration = GetTotemInfo(1)
			if not totemname or totemname == "" then -- no fire totem deployed so recommend it be dropped
				return true
			end
			if start and strmatch(totemname, C["Totem of Wrath"]) then
				local timeleft = start + duration - GetTime()
				return timeleft <= PriorityQueue.db.char.priority.cooldown 
			end
		end
		return false
	end 

PriorityQueue.priorityTable.name["mw5_hw"] = L["MW5 Healing Wave"]
PriorityQueue.priorityTable.test["mw5_hw"] = 
	function () 
		if PriorityQueue.db.char.priority.chingroup == true and GetNumPartyMembers() > 0 then
			PriorityQueue.priorityTable.icon["mw5_hw"] = C["Chain Heal Icon"]
		else
			PriorityQueue.priorityTable.icon["mw5_hw"] = C["Healing Wave Icon"]
		end
		local healthpercent = 100 * UnitHealth("player") / UnitHealthMax("player")
		return PriorityQueue.db.char.msstacks == 5 and healthpercent <= PriorityQueue.db.char.priority.hwhealth
	end
	
PriorityQueue.priorityTable.name["mw4_hw"] = L["MW5 Healing Wave"]
PriorityQueue.priorityTable.test["mw4_hw"] = 
	function () 
		if PriorityQueue.db.char.priority.chingroup == true and GetNumPartyMembers() > 0 then
			PriorityQueue.priorityTable.icon["mw4_hw"] = C["Chain Heal Icon"]
		else
			PriorityQueue.priorityTable.icon["mw4_hw"] = C["Healing Wave Icon"]
		end
		local healthpercent = 100 * UnitHealth("player") / UnitHealthMax("player")
		return PriorityQueue.db.char.msstacks >= 4 and healthpercent <= PriorityQueue.db.char.priority.hwhealth
	end
	
PriorityQueue.priorityTable.name["ls"] = C["Lightning Shield"]
PriorityQueue.priorityTable.icon["ls"] = C["Lightning Shield Icon"]
PriorityQueue.priorityTable.test["ls"] = 
	function ()
		local orbs, shield, shieldExpires = PriorityQueue:GetShieldInfo()
		local timeleft = shieldExpires - GetTime()
		return timeleft <= PriorityQueue.db.char.priority.cooldown or orbs <= 1
	end

PriorityQueue.priorityTable.name["ws"] = C["Water Shield"]
PriorityQueue.priorityTable.icon["ws"] = C["Water Shield Icon"]
PriorityQueue.priorityTable.test["ws"] = 
	function ()
		local orbs, shield, shieldExpires = PriorityQueue:GetShieldInfo()
		local timeleft = shieldExpires - GetTime()
		return timeleft <= PriorityQueue.db.char.priority.cooldown or orbs <= 1
	end

----------------------
-- Buff functions --
----------------------
	
function PriorityQueue:GetShieldInfo()
	local index = 1
	while UnitBuff("PLAYER", index) do
		local name, _, _, count, _, _, shieldExpires = UnitBuff("PLAYER", index)
		if name ==  C["Water Shield"] or name == C["Lightning Shield"] or name == C["Earth Shield"] then
			return count, name, shieldExpires
		end
		index = index + 1
	end
	return 0, "", 0
end

function PriorityQueue:GetMaelstromInfo()
	local index = 1
	while UnitBuff("PLAYER", index) do
		local name, _, _, count, _, _, maelstromTime = UnitBuff("PLAYER", index)
		if name == C["Maelstrom Weapon"] then
			return count, maelstromTime
		end
		index = index + 1
	end
	return 0, 0 
end

function PriorityQueue:CheckShamanisticRage()
	local srtalent
	if self.patch31 then
		_, _, _, _, srtalent = GetTalentInfo(2,26)
	else
		_, _, _, _, srtalent = GetTalentInfo(2,25)
	end
	if srtalent == 1 then
		local startTime, duration = GetSpellCooldown(C["Shamanistic Rage"])
		if startTime then 
			local timeleft = startTime + duration - GetTime()
			local manapercent = 100 * UnitMana("player") / UnitManaMax("player")
			if manapercent < self.db.char.priority.srmana and timeleft <= self.db.char.priority.cooldown then
				return true
			end
		end
	end
	return false
end
